;
;***** DEFINITION D ADRESSES
;
;ADRESSE DU POINT DE BRANCHEMENT A NEWDOS
NEWDOS EQU 402DH
;ADRESSE DU SAUT A LA ROUTINE DE TRAITEMENT DES INTERRUPTIONS
;D HORLOGE DANS NEWDOS
HORDOS EQU 45FEH
;ADRESSE DE LA ROUTINE DE TRAITEMENT DES INTERRUPTIONS D HORLOGE
INTHOR EQU 4610H
;ADRESSE DES COMPTEURS DE SECONDE,MINUTE,HEURE DE NEUDOS
CPTSEC EQU 4041H
CPTMIN EQU 4042H
CPTHEU EQU 4043H
;ADRESSES DES ROUTINES DE LA ROM UTILISEES :
AFFECR EQU 33H  ;AFFICHAGE A L ECRAN
LECCLA EQU 49H  ;LECTURE DU CLAVIER
ATTENT EQU 60H  ;TEMPORISATION
ECRBLA EQU 1C9H ;EFFACAGE DE L'ECRAN
;ADRESSE DU DEBUT DE L ECRAN
DEBECR EQU 3C00H
;LONGUEUR D UNE LIGNE D ECRAN
LIGNE EQU 64T
;
;***** MACROINSTRUCTIONS
;
;* COMPAR
;COMPARE LE CONTENU D UN COMPTEUR DE NEWDOS (HEURE,MINUTE,SECONDE)
;AVEC LE CONTENU DE L HEURE D ALARME . SI CES CONTENUS SONT
;DIFFERENTS , ON SAUTE A L ADRESSE RETDOS , SINON POURSUITE EN
;SEQUENCE
;
COMPAR	MACRO #CPT,#ALA
	LD A,(#CPT)
	LD B,A
	LD A,(#ALA)
	CP B
	JR NZ,AETDOS
	ENDM

;*VERIF
;VERIFIE LA VALIDITE DE L HEURE TAPEE AU CLAVIER :
;       TOUT CARACTERE NON NUMERIQUE EST REFUSE
;       UN CHIFFPE S IL EST VALABLE (0 A 2 POUR DIZAINE D HEURE
;0 A 3 POUR HEURE , 0 A 5 POUR DIZAINE MINUTE SECONDE , 0 A 9 POUR
;MINUTE SECONDE) EST AFFICHE . PUIS SON CODE ASCII EST TRANSFORME
;EN CHIFFRE HEXADECIMAL STOCKE DANS LES REGISTRES A ET B
;
VERIF	MACRO #LBL,#CODASC
#LBL	CALL LECCLA
	CP #CODASC
	JR NC,#LBL
	CP '0'
	JR C,#LBL
	CALL AFFECR
	SUB 30H
	LD B,A
	ENDM
;* TRANSF
;TRANSFERT A L ADRESSE DEST LE BLOC D OCTETS DEBUTANT A L ADRESSE
;SOURCE ET DE LONGEUR LONG
;
TRANSF	MACRO #SOURCE,#DEST,#LONG
	LD HL,#SOURCE
	LD DE,#DEST
	LD BC,#LONG
	LDIR
	ENDM
;
;******** ROUTINE D ENTREE DE L HEURE D ALARME
;
ORG 5200H
;
;* SOUS PROGRAMME DIZAIN
;MULTIPLIE PAR 10 UN CHIFFRE HEXADECIMAL CONTENU DANS LE REGISTRE B
;LE RESULTAT SE TROUVE DANS LA REGISTRE A
;
DIZAIN	LD A,0
BOUC	ADD A,10T
	DJNZ BOUC
	RET
;
DEBUT	LD SP,5400H ; INITIALISATION REGISTRE POINTEUR DE PILE
	CALL ECRBLA
	LD A,14T	; POSITIONEMENT
	CALL AFFECR	;DU CURSEUR
	LD A,28T	;AU DEBUT
	CALL AFFECR	;DE LA
	LD A,26T	;DEUXIEME
	CALL AFFECR	;LIGNE
TRANSF	MESSA,DEBECR,35T ;AFFICHAGE DU MESSAGE UTILISATEUR
VERIF	LBL1,51T
	CALL DIZAIN
	LD (ALAHEU),A	; ENTREE
VERIF	LBL2,58T
	LD A,(ALAHEU)
	ADD A,B
	LD (ALAHEU),A
	LD A,':'	;DE
	CALL AFFECR
VERIF	LBL3,54T
	CALL DIZAIN
	LD (ALAMIN),A
VERIF	LBL4,58T	;L HEURE
	LD A,(ALAMIN)
	ADD A,B
	LD (ALAMIN),A
	LD A,','	;D ALARME
	CALL AFFECR
VERIF	LBL5,54T
	CALL DIZAIN
	LD (ALASEC),A 
VERIF	LBL6,58T	;AU CLAVIER
	LD A,(ALASEC)
	ADD A,B
	LD (ALASEC),A
	LD A,29T
	CALL AFFECR	;REPOSITIONEMENT
	LD A,26T
	CALL AFFECR	;DU CURSEUR
	DI		;MODIFICATION DE NEW DOS:
TRANSF	BRANCH,HORDOS,2	;BRANCHEMENT A LA
	EI		;ROUTINE DETECT
	JP NEWDOS
MESSA	DEFM 'RENTRER L HEURE D ALARME (HH:MM:SS)'
BRANCH	DEFW DETECT
;
;***** ROUTINE DE DETECTION DE L ALARME
;
ORG 0FB70H
;
;* DEFINITON DE L ECRAN D ALARME
;
DRING	DEFM '                                      P              O             R'
	DEFB '       R                    R     '
DD	DEFW 0BFBFH
	DEFW 0BFBFH
	DEFW 0BFBFH
	DEFW 0BFBFH
	DEFB ' N      '
	DEFB 0BFH
	DEFB '      '
	DEFB 0BFH
	DEFB ' T      '
	DEFB 0BFH
	DEFB '      '
	DEFB 0BFH
	DEFM ' R      '
	DEFB 0BFH
	DEFB '      '
	DEFB 0BFH
	DEFM ' E      '
	DEFB 0BFH
	DEFM '      '
	DEFB 0BFH
	DEFM ' R      '
	DEFB 0BFH
	DEFB '      '
	DEFB 0BFH
	DEFM '        '
	DEFW 0BFBFH
	DEFW 0BFBFH
	DEFM '   U           N           E     '
	DEFW 0BFBFH
	DEFW 0BFBFH
	DEFW 0BFBFH
	DEFW 0BFBFH
	DEFM '        '
	DEFB 0BFH
	DEFM '   '
	DEFB 0BFH
	DEFM '    N      '
	DEFB 0BFH
	DEFM '    O      '
	DEFB 0BFH
	DEFM '    U      '
	DEFW 0BFBFH
	DEFM '   V       '
	DEFB 0BFH
	DEFM ' '
	DEFB 0BFH
	DEFM '  '
	DEFB 0BFH
	DEFM '  E        '
	DEFB 0BFH
	DEFM '    '
	DEFB 0BFH
	DEFM ' L           L           E     '
	DEFB 0BFH
	DEFM '      '
	DEFB 0BFH
	DEFM '        '
	DEFW 0BFBFH
	DEFW 0BFBFH
	DEFW 0BFBFH
	DEFW 0BFBFH
	DEFM ' H      '
	DEFB 0BFH
	DEFM '      '
	DEFB 0BFH
	DEFM ' E           U           R     '
	DEFW 0BFBFH
	DEFW 0BFBFH
	DEFW 0BFBFH
	DEFW 0BFBFH
	DEFM ' E       '
	DEFB 0BFH
	DEFM '            '
	DEFB 0BFH
	DEFM '       D    '
	DEFB 0BFH
	DEFM '            '
	DEFB 0BFH
	DEFM '    A       '
	DEFB 0BFH
	DEFM '            '
	DEFB 0BFH
	DEFM '   L     '
	DEFW 0BFBFH
	DEFW 0BFBFH
	DEFW 0BFBFH
	DEFW 0BFBFH
	DEFB 0BFH
	DEFM ' A           R           M      '
	DEFW 0BFBFH
	DEFW 0BFBFH
	DEFM '   E     '
	DEFB 0BFH
	DEFM '    '
	DEFB 0BFH
	DEFM '        '
	DEFB 0BFH
	DEFM '     '
	DEFB 0BFH
	DEFM '       '
	DEFB 0BFH
	DEFM '     '
	DEFB 0BFH
	DEFM '       '
	DEFB 0BFH
	DEFM '   '
	DEFB 0BFH
	DEFM ' '
	DEFB 0BFH
	DEFM ' T     '
	DEFB 0BFH
	DEFM '   '
	DEFB 0BFH
	DEFM '  '
	DEFB 0BFH
	DEFM ' A      '
	DEFB 0BFH
	DEFM '  '
	DEFW 0BFBFH
	DEFW 0BFBFH
	DEFM ' P           E           Z      '
	DEFW 0BFBFH
	DEFW 0BFBFH
	DEFW 0BFBFH
	DEFM ' '
	DEFB 0BFH
	DEFM '           "           A           L           A           R           M           E      '
	DEFM '     "                                     '
;
NORMAL	DEFW	INTHOR
DETECT	COMPAR	CPTSEC,ALASEC	;HEURE COURANTE
	COMPAR	CPTMIN,ALAMIN	; ''
	COMPAR	CPTHEU,ALAHEU	;HEURE D ALARME ?
;SI OUI , MODIFICATION DE NEWDOS : SUPPRESSION DU BRANCHEMENT A
TRANSF	NORMAL,HORDOS,2	;LA ROUTINE DETECT
	LD A,28T	;SINON
	CALL AFFECR
	LD A,26T
	LD B,13T
BOU	CALL AFFECR	:AFFICHAGE DE
	DJNZ BOU
	LD IX,DRING
	LD A,0

ROTECR	LD ( CPTCOL ), A
	LD HL,DEBECR	;L ECRAN
	LD (DEBLIG),HL
ROTLIG	LD DE,(DEBLIG)
	LD BC,1
	ADD HL,BC
	LD BC,LIGNE-1	;D ALARME
	LDIR
	LD A,(IX)
	DEC HL
	LD (HL),A
	INC HL		;ET
	INC IX
	LD HL,(DEBLIG)
	LD BC,LIGNE
	ADD HL,BC
	LD (DEBLIG),HL	;BRANCHEMENT
	BIT 6,H
	JR Z,ROTLIG
	LD BC,1000
	CALL ATTENT
	LD A, (CPTCOL)	;A
	INC A
	CP LIGNE
	JR NZ,ROTECR
	EI
	JP NEWDOS	;NEWDOS
RETDOS	JP INTHOR
ALAHEU	DEFS 1
ALAMIN	DEFS 1
ALASEC	DEFS 1
CPTCOL	DEFS 1
DEBLIG	DEFS 2
	END	DEBUT
